class OkResult {
    constructor(contents) {
        this.contents = contents;
    }
    isOk() {
        return true;
    }
    isErr() {
        return false;
    }
    mapOk(mapper) {
        return new OkResult(mapper(this.contents));
    }
    mapErr(mapper) {
        return this;
    }
    unwrapOrThrow() {
        return this.contents;
    }
    unwrapErrOrThrow() {
        throw new Error("Tried to unwrap an OkResult's error");
    }
}
class ErrResult {
    constructor(contents) {
        this.contents = contents;
    }
    isOk() {
        return false;
    }
    isErr() {
        return true;
    }
    mapOk(mapper) {
        return this;
    }
    mapErr(mapper) {
        return new ErrResult(mapper(this.contents));
    }
    unwrapOrThrow() {
        throw new Error("Tried to unwrap an ErrResult's error");
    }
    unwrapErrOrThrow() {
        return this.contents;
    }
}
export function resultOf(value) {
    return new OkResult(value);
}
export function resultOfErr(value) {
    return new ErrResult(value);
}
//# sourceMappingURL=Result.js.map